'use strict';
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var path = require("path");
var fs = require("fs");
var util_1 = require("util");
var fileExistAsync = util_1.promisify(fs.exists);
var readFileAsync = util_1.promisify(fs.readFile);
var writeFileAsync = util_1.promisify(fs.writeFile);
function fixArgvs(data) {
    for (var _i = 0, _a = Object.keys(data); _i < _a.length; _i++) {
        var key = _a[_i];
        var value = data[key];
        if (typeof value === 'object') {
            data[key] = fixArgvs(value);
            continue;
        }
        if (typeof value === 'string') {
            if (value === 'false') {
                data[key] = false;
                continue;
            }
            if (value === 'true') {
                data[key] = true;
                continue;
            }
            if (/^[1-9]+[0-9]*(\.[0-9]+)?$/.test(value)) {
                data[key] = Number(value);
                continue;
            }
            try {
                data[key] = JSON.parse(value);
            }
            catch (_b) { }
        }
    }
    return data;
}
var argvEnvKey = 'app';
var logPrefix = 'NativeScript Environment: ';
function processArgv($logger, argv) {
    if (!argv || !argv.env) {
        $logger.info(logPrefix + " tns run <platform> --env not provided.");
        return {};
    }
    var env = argv.env;
    if (argvEnvKey in env) {
        return fixArgvs(env[argvEnvKey]);
    }
    else {
        $logger.info(logPrefix + " no --env.app variables.");
        return {};
    }
}
module.exports = function beforePrepare($logger, $projectData) {
    return __awaiter(this, void 0, void 0, function () {
        var appPath, $options, appEnvironment, configFilepath, oldAppEnvironmentJSON, appEnvironmentJSON;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    appPath = $projectData.appDirectoryPath;
                    $options = $projectData.$options;
                    appEnvironment = processArgv($logger, $options.argv);
                    configFilepath = path.join(appPath, 'environment.json');
                    oldAppEnvironmentJSON = null;
                    return [4, fileExistAsync(configFilepath)];
                case 1:
                    if (!_a.sent()) return [3, 3];
                    return [4, readFileAsync(configFilepath, { encoding: 'UTF-8' })];
                case 2:
                    oldAppEnvironmentJSON = _a.sent();
                    _a.label = 3;
                case 3:
                    appEnvironmentJSON = JSON.stringify(appEnvironment || {}, null, 2);
                    if (oldAppEnvironmentJSON && oldAppEnvironmentJSON === appEnvironmentJSON) {
                        $logger.info(logPrefix + " Environment vars not changed");
                        return [2];
                    }
                    return [4, writeFileAsync(configFilepath, appEnvironmentJSON)];
                case 4:
                    _a.sent();
                    $logger.info(logPrefix + " Successfully created:", configFilepath);
                    return [2];
            }
        });
    });
};
